// liveinfo.js
// 12/11/05 v0.2+20121105mod
//
// v0.2modからの変更点
//   クロージャ内で処理していたのを、グローバル化させました。（たいして速度変わらないのでｗ）
//   【バグ修正】
//     IE9でバグっていたのを修正
//   【機能追加】
//     マイリストの内容を全部読み込んで、流れた動画がマイリスト登録済みかどうか視認できるようにした
//     キャッシュ削除機能を追加しました。
//     更新リンクを設置しました。キャッシュの有無を判断するだけの簡単なものです。





var liveinfo_item = new Array(liveinfo_listNum);
var liveinfo_MylistObj = new Object();
var liveinfo_holder = 0;
var liveinfo_mg,liveinfo_handle;
var liveinfo_community_id="";
// liveinfo機能を自動で起動するかどうかチェック
var liveinfo_checkliveinfo = function() {
	return /(<category>動画紹介<\/category>|<is_ns_stream>\d+<\/is_ns_stream>)/.test((typeof getGPS==="function"?getGPS():typeof Nicolive_JS_Conf.GPS.value_by_gps==="string"?decodeURIComponent(Nicolive_JS_Conf.GPS.value_by_gps):"").replace(/<default_community>([^<]+)<\/default_community>/,function(s0,s1){liveinfo_community_id=s1;return s0}));
};
// mylistgroupを取得
var liveinfo_getmylistgroup = function() {
	$("nl_liveInfoList").innerHTML = 'マイリストを取得しています...',
	new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/api/mylistgroup/list",{
		method: 'get',
		onSuccess: function(httpObj) {
			liveinfo_mg=eval("("+httpObj.responseText+")");
			liveinfo_mg.mylistgroup.unshift({id:0,name:"とりあえずマイリスト"});
			liveinfo_getmylist(0);
		}
	});
};
var liveinfo_getmylist = function(i) {
	if(liveinfo_mg.mylistgroup[i]&&liveinfo_loadAllMylist) {
		$("nl_liveInfoList").innerHTML = 'マイリスト「'+liveinfo_mg.mylistgroup[i].name+'」を取得しています...';
		new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/api/"+(liveinfo_mg.mylistgroup[i].id==0?"deflist":"mylist")+"/list"+(liveinfo_mg.mylistgroup[i].id==0?"":"?group_id="+liveinfo_mg.mylistgroup[i].id),{
			method: "get",
			onSuccess: function(httpObj) {
				var mi = eval("("+httpObj.responseText+")");
				for(var n=0,I;I=mi.mylistitem[n];n++) {
					if(I.item_type)continue;
					if(!liveinfo_MylistObj[I.item_data.video_id])liveinfo_MylistObj[I.item_data.video_id]=new Array();
					liveinfo_MylistObj[I.item_data.video_id][liveinfo_MylistObj[I.item_data.video_id].length]=liveinfo_mg.mylistgroup[i].name;
				}
				liveinfo_getmylist(i+1);
			}
		});
	}else{
		$("nl_liveInfoList").innerHTML = '動画リストを取得しています...';
		// 2秒ごとにリストを取得、更新されてたらページ書き換えとか
		liveinfo_handle = setInterval(liveinfo_getLiveList, 2000);
	}
};
// メイン関数。これ呼べばデータ取得･アップデート
// Extensionから動画リスト取得して処理にまわす
var liveinfo_getLiveList = function() {
	new Ajax.Request("http://live.nicovideo.jp/cache/liveinfo",{
		method: 'get',
		onSuccess: liveinfo_getLiveListResponce
	});
};
// リストが更新されてたらデータ取得とか表示更新とか
var liveinfo_getLiveListResponce = function(httpObj) {
	if (httpObj.responseText != "") {
		if(!liveinfo_item[liveinfo_holder]) {
			liveinfo_item[liveinfo_holder]={id:"",isCache:"",title:"unknown",count:"",comment:"",mylist:"",lengths:"",size_high:0,size_low:0,user_id:"",user_name:"",date:"",desc:"",tags:new Array(),mylist_flag:-1};
		}
		var list = httpObj.responseText.split(",");
		if (list[0] == "" || list[0]!=Video.id || list[1] == liveinfo_item[liveinfo_holder].id) return;
		liveinfo_holder = (liveinfo_holder+1)%liveinfo_listNum;
		liveinfo_item[liveinfo_holder].id = list[1];
		liveinfo_item[liveinfo_holder].isCache = list[2];
		liveinfo_item[liveinfo_holder].title = undefined;
		liveinfo_getData();
	}
};
// thumbinfoからデータ取得
var liveinfo_getData = function() {
	new Ajax.Request("http://" + location.host + "/liveinfo_ext.nicovideo.jp/api/getthumbinfo/"+liveinfo_item[liveinfo_holder].id+"?_="+(new Date).getTime(), {
		method: "get",
		onSuccess: liveinfo_getDataResponse
	});
};
var liveinfo_getDataResponse = function(httpObj) {
	var text = httpObj.responseText;
	if(!text.match(/<\/nicovideo_thumb_response>/)) {
		liveinfo_getData();
		return false;
	}
	var taghtml = "";
	text.replace(/<title>(.+)<\/title>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].title = s1.replace(/&apos;/g,"'").replace(/&amp;/g,"&").replace(/&nbsp;/g,"");
		return s0;
	}).replace(/<view_counter>(.+)<\/view_counter>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].count = s1;
		return s0;
	}).replace(/<comment_num>(.+)<\/comment_num>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].comment = s1;
		return s0;
	}).replace(/<mylist_counter>(.+)<\/mylist_counter>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].mylist = s1;
		return s0;
	}).replace(/<length>(.+)<\/length>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].lengths = s1;
		return s0;
	}).replace(/<size_high>(.+)<\/size_high>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].size_high = parseInt(s1);
		return s0;
	}).replace(/<size_low>(.+)<\/size_low>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].size_low = parseInt(s1);
		return s0;
	}).replace(/<user_id>(.+)<\/user_id>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].user_id = s1;
		return s0;
	}).replace(/<first_retrieve>(\d+)-(\d+)-(\d+)T(\d+:\d+:\d+)\+09:00<\/first_retrieve>/,function(s0,s1,s2,s3,s4) {
		liveinfo_item[liveinfo_holder].date = s1+"/"+s2+"/"+s3+" "+s4;
		return s0;
	}).replace(/<description>([\s\S]+)<\/description>/,function(s0,s1) {
		liveinfo_item[liveinfo_holder].desc = s1.replace(/&apos;/g,"'").replace(/&amp;/g,"&").replace(/&nbsp;/g,"");
		return s0;
	}).replace(/<tags domain="jp">([\s\S]+?)<\/tags>/,function(s0,s1) {
		taghtml += "<br><span style='color:blue;'>"
		+(s1.replace(/<tag[^>]*>([^<]+)<\/tag>/g,function(t0,t1) {
			liveinfo_item[liveinfo_holder].tags[liveinfo_item[liveinfo_holder].tags.length]=t1;return t0;
		}).replace(/<tag[^>]*>/g,"　").replace(/<\/tag>/g,""))+"</span>";
		return s0;
	}).replace(/<tags domain="(tw|de|es)">([\s\S]+?)<\/tags>/g,function(s0,s1,s2) {
		if(liveinfo_showoverseatags) {
			taghtml += "<br><span style='color:green;'>"
			+(s2.replace(/<tag[^>]*>([^<]+)<\/tag>/g,function(t0,t1) {
				liveinfo_item[liveinfo_holder].tags[liveinfo_item[liveinfo_holder].tags.length]=t1;return t0;
			}).replace(/<tag[^>]*>/g,"　").replace(/<\/tag>/g,""))+"</span>";
		}
		return s0;
	});
	liveinfo_item[liveinfo_holder].desc += taghtml;

	liveinfo_nlGetTag();
};
var liveinfo_nlGetTag = function() {
	if(liveinfo_getTagFlg)
		new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/cache/taglist?id=" + liveinfo_item[liveinfo_holder].id + "&tag=" + encodeURIComponent(liveinfo_item[liveinfo_holder].tags.join(' ')) + "&time="+(new Date).getTime(), {
			method: "get",
			onSuccess: function(httpObj) {
				liveinfo_getUsername();
			}
		});
	else
		liveinfo_getUsername();
};
var liveinfo_getUsername = function() {
	if(liveinfo_item[liveinfo_holder].user_id=="")
		liveinfo_updateView();
	else
		new Ajax.Request("http://" + location.host + "/liveinfo_ext.nicovideo.jp/thumb_user/"+liveinfo_item[liveinfo_holder].user_id, {
			method: "get",
			onSuccess: function(httpObj) {
				if(httpObj.responseText.match(/<p class="TXT12"><a[^>]+><strong>(.+)<\/strong><\/a><\/p>/))
					liveinfo_item[liveinfo_holder].user_name = RegExp.$1;
				else
					liveinfo_item[liveinfo_holder].user_name = "";
				liveinfo_updateView();
			}
		});
};
// 表示を更新する
var liveinfo_updateView = function() {
	var infoList = $("nl_liveInfoList");
	var str = '<p align="right">マイリスト登録先：<select id="addMylistTarget">';
	for(var i=0,_mg;_mg=liveinfo_mg.mylistgroup[i];i++)
		str+='<option value="'+_mg.id+'">'+_mg.name+'</option>';
	str+='</select><input id="liveinfo_addMylistComment" typw="text" size="50" value="'+
		liveinfo_addMylistCommentTemplete
				.replace(/{com_id}/ig,liveinfo_community_id)
				.replace(/{title}/ig,Video.title.replace(/\u200b/g,""))
				.replace(/{lv}/ig,Video.id)+'"></p>';
	var f = function(i) {
		if(i>0) {
			var HolderId = (liveinfo_holder+i)%liveinfo_listNum;
			if(liveinfo_item[HolderId].id) {
				new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/cache/ajax_info?"+liveinfo_item[HolderId].id, {
					method: "get",
					onSuccess: function(httpObj) {
						var s = httpObj.responseText.split(",");
						if(s[4]==0) {
							if(s[1]=="low") {
								liveinfo_item[HolderId].isCache = "low";
							}else{
								liveinfo_item[HolderId].isCache = "cache";
							}
						}else{
							liveinfo_item[HolderId].isCache = "";
						}
						str += liveinfo_getInfoLine(HolderId);
						f(i-1);
					}
				});
			}else{
				f(i-1);
			}
		}else{
			str+='<a href="javascript:void(0)" onclick="liveinfo_updateView()" style="font-size:10px;">更新</a>'
			infoList.innerHTML = str;
		}
	};
	f(liveinfo_listNum);
};
// movieFetcherとかマイリス登録後の処理とかも埋め込む
var liveinfo_getInfoLine = function(HolderId) {
	var str = '<table style="width:100%;"><tr><td width="13%">'+liveinfo_item[HolderId].id;
	if (nicofetch && liveinfo_item[HolderId].isCache != "cache")
		str += '<a href="javascript:void(0)" onclick="nicofetch(this,\''+liveinfo_item[HolderId].id+'\',2)" style="font-size:10px;">(fetch)</a>';
	else
		str += '<a href="javascript:void(0)" onclick="liveinfo_removeId(\''+liveinfo_item[HolderId].id+'\')" style="font-size:10px;">(del)</a>';
	str += '</td><td>'+
		'<a href="http://www.nicovideo.jp/watch/'+liveinfo_item[HolderId].id+'" target="_blank" onmouseover="$(\'nl_'+liveinfo_item[HolderId].id+'\').style.display=\'\'" onmouseout="$(\'nl_'+liveinfo_item[HolderId].id+'\').style.display=\'none\'"';
	if (liveinfo_item[HolderId].isCache == "cache")
		str += ' style="color:#C00000"';
	else if (liveinfo_item[HolderId].isCache == "low")
		str += ' style="color:#C08000"';
	str += '>'+liveinfo_item[HolderId].title+'</a></td>'+
		'<td width="3%">再生</td><td width="7%">'+liveinfo_item[HolderId].count+'</td>'+
		'<td width="3%">投稿</td><td width="7%">'+(liveinfo_item[HolderId].user_name==''?'':'<a href="http://www.nicovideo.jp/user/'+liveinfo_item[HolderId].user_id+'" target="_blank" title="'+liveinfo_item[HolderId].user_name+'さんのユーザーページへ">'+liveinfo_item[HolderId].user_name+'</a>')+'</td>';
	if(liveinfo_MylistObj[liveinfo_item[HolderId].id])
		str += '<td width="5%"><span title="'+liveinfo_MylistObj[liveinfo_item[HolderId].id].join(",")+'">登録(済)</span></td>';
	else if (liveinfo_item[HolderId].mylist_flag < 0)
		str += '<td width="5%"><a href="javascript:void(0)" onclick="addmylist(\''+liveinfo_item[HolderId].id+'\'); return false;">登録</a></td>'
	else if (liveinfo_item[HolderId].mylist_flag == 1)
		str += '<td width="5%">登録(済)</td>';
	else
		str += '<td width="5%">登録(失)</td>';
	str += '<td width="7%">'+liveinfo_item[HolderId].mylist+'</td>'+
		'<td width="3%">コメ</td><td width="7%">'+liveinfo_item[HolderId].comment+'</td>'+
		'<td width="3%">長さ</td><td width="7%">'+liveinfo_item[HolderId].lengths+'</td></tr></table>';
// 動画説明文
	var length_ms = liveinfo_item[HolderId].lengths.replace(/(\d+):(\d+)/,function(s0,s1,s2){
		return (parseInt(s1)*60+parseInt(s2))*1000;
	});
	var R = 0, r = 0;
	if(length_ms>0) {
		R = liveinfo_item[HolderId].size_high*0.008/length_ms;
		r = liveinfo_item[HolderId].size_low*0.008/length_ms;
	}
	str+='<div id="nl_'+liveinfo_item[HolderId].id+'" style="width:920px; position:absolute; background-color:#ffffd0; border:1px solid gray; display:none;z-index:9;">'+
		'投稿：'+liveinfo_item[HolderId].date+' 平均ビットレート：P='+(R>0?R.toFixed(2):0)+'kbps eco='+(r>0?r.toFixed(2):0)+'kbps '+(liveinfo_MylistObj[liveinfo_item[HolderId].id]?'登録済みマイリスト：'+liveinfo_MylistObj[liveinfo_item[HolderId].id].join(','):'')+
		'<br>'+liveinfo_item[HolderId].desc+'</div>';
	return str;
};
// マイリスト追加処理については、全て自前で処理
window.addmylist = function(smid,thread_id) {
	if(!confirm(smid+" をマイリスト 『"+liveinfo_mg.mylistgroup[$("addMylistTarget").selectedIndex].name+"』に登録しますか？")) return false;
	var group_id = $("addMylistTarget").value;
	new Ajax.Request("http://" + location.host + "/liveinfo_www.nicovideo.jp/mylist_add/video/"+smid, {
		method: "get",
		onSuccess: function(r) {
			var token,HolderId;
			r.responseText
				.replace(/NicoAPI\.token\s*=\s*\"(.*)\";/,function(s0,s1) {
					token=s1;
				}).replace(/item_id\"\s*value=\"(.*)\">/,function(s0,s1) {
					if(!thread_id)thread_id=s1;
				});
			if(!token||!thread_id) {
				for (var i=0; i<liveinfo_listNum; i++) {
					HolderId = (liveinfo_holder+i)%liveinfo_listNum;
					if (smid == liveinfo_item[HolderId].id) {
						liveinfo_item[HolderId].mylist_flag = 2;
						break;
					}
				}
				liveinfo_updateView();
				return false;
			}
			for (var i=0; i<liveinfo_listNum; i++) {
				HolderId = (liveinfo_holder+i)%liveinfo_listNum;
				if (smid == liveinfo_item[HolderId].id) {
					liveinfo_item[HolderId].mylist_flag = 0;
					break;
				}
			}
			var description = $("liveinfo_addMylistComment").value;
			var url = "http://" + location.host + "/liveinfo_www.nicovideo.jp/api/"+(group_id==0?"deflist":"mylist")+"/add"
			new Ajax.Request(url, {
				method: "post",
				parameters: (group_id==0?"":("group_id="+group_id+"&"))+"item_type=0&item_id="+encodeURIComponent(thread_id)+"&description="+encodeURIComponent(description)+"&token="+encodeURIComponent(token),
				onSuccess: function(xmlHttp) {
					var resJson=eval("("+xmlHttp.responseText+")");
					var addMylistResultXML='';
					if(resJson.status=="ok") {
						if(!liveinfo_MylistObj[smid])liveinfo_MylistObj[smid]=new Array();
						liveinfo_MylistObj[smid][liveinfo_MylistObj[smid].length] = liveinfo_mg.mylistgroup[$("addMylistTarget").selectedIndex].name;
						addMylistResultXML = '<?xml version="1.0" encoding="utf-8"?>\n<addmylist status="ok"/>';
					}else{
						addMylistResultXML = resJson.error.code=="EXIST"?'<?xml version="1.0" encoding="utf-8"?>\n<addmylist status="fail"><error><code>EXIST</code></error></addmylist>':"";
					}
					var result = resJson.status=="ok"?1:2;
					for (var i=0; i<liveinfo_listNum; i++) {
						HolderId = (liveinfo_holder+i)%liveinfo_listNum;
						if (liveinfo_item[HolderId].mylist_flag == 0) {
							liveinfo_item[HolderId].mylist_flag = result;
							break;
						}
					}
					try{
						if(addMylistResultXML!='')
							// ↓これ、Qだとなぜかエラーになるのよね。改善策きぼんｗ
							$("flvplayer").setAddmylistResult(addMylistResultXML);
					}catch(e) {
					}finally{
						liveinfo_updateView();
					}
				}
			});
		}
	});
};
window.liveinfo_removeId = function(_id) {
	new Ajax.Request("/cache/ajax_rm",{
		method : 'get',
		parameters : _id,
		onSuccess : liveinfo_updateView
	});
};
Event.observe(window, "load", function() {
	var _elm = $("player_btm")||$("watch_player_bottom_box");
	_elm.insert({after: '<div id="nl_liveInfoList" style="background-color: white;"></div>'});
	var flag = liveinfo_checkliveinfo();
	if(flag) {
		liveinfo_getmylistgroup();
	} else {
		$("nl_liveInfoList").innerHTML = '<input type="button" value="liveinfoを起動する" onclick="liveinfo_getmylistgroup()">';
	}
}, false);
